unit DList;

interface

type
  pointertype=^nodetype;
  nodetype=record
             info: integer;
             next,prev: pointertype;
           end;
  TDList=class(Tobject)
  private
    top,bottom: pointertype;
  public
    constructor create;
    destructor destroy; override;
    procedure push(v: integer);
    procedure insert(v: integer);
    function pop: integer;
    procedure remove;
    function first: integer;
    function last: integer;
    function Nfirst: integer;
    function Nlast: integer;
    function empty: boolean;
  end;

implementation

constructor TDList.create;
begin
  top:= nil;
  bottom:= nil;
end;

destructor TDList.destroy;
begin
  while top<>nil do pop;
  inherited;
end;

{indst forrest i ken}
procedure TDList.push;
var
  newnode: pointertype;
begin
  new(newnode);
  newnode^.info:= v;
  newnode^.next:= nil;
  newnode^.prev:= nil;
  if top=nil then
  begin
    top:= newnode;
    bottom:= newnode;
  end
    else
  begin
    top^.prev:= newnode;
    newnode^.next:= top;
    top:= newnode;
  end;
end;

{slet forrest i ken}
function TDList.pop;
var
  tmp: pointertype;
begin
  if top<>nil then
  begin
    result:= top^.info;
    if top^.next=nil then
    begin
      dispose(top);
      top:= nil;
      bottom:= nil;
    end
      else
    begin
      tmp:= top;
      tmp^.next^.prev:= nil;
      top:= top^.next;
      dispose(tmp);
    end;
  end;
end;

{indst bagest i ken}
procedure TDList.insert;
var
  newnode: pointertype;
begin
  new(newnode);
  newnode^.info:= v;
  newnode^.next:= nil;
  newnode^.prev:= nil;
  if bottom=nil then
  begin
    top:= newnode;
    bottom:= newnode;
  end
    else
  begin
    bottom^.next:= newnode;
    newnode^.prev:= bottom;
    bottom:= newnode;
  end;
end;

{slet bagest i ken}
procedure TDList.remove;
var
  tmp: pointertype;
begin
  if bottom<>nil then
  begin
    if bottom^.prev=nil then
    begin
      dispose(bottom);
      top:= nil;
      bottom:= nil;
    end
      else
    begin
      tmp:= bottom;
      tmp^.prev^.next:= nil;
      bottom:= bottom^.prev;
      dispose(tmp);
    end;
  end;
end;

function TDList.last;
begin
  if top<>nil then result:= top^.info;
end;

function TDList.first;
begin
  if bottom<>nil then result:= bottom^.info;
end;

function TDList.Nlast;
begin
  if (top<>nil) and (top^.next<>nil) then result:= top^.next^.info;
end;

function TDList.Nfirst;
begin
  if (bottom<>nil) and (bottom^.prev<>nil) then result:= bottom^.prev^.info;
end;

function TDList.empty: boolean;
begin
  result:= (top=nil);
end;

end.
 