unit nearest;

interface

function NearestNode(maxlimit: double; MainCoord,count: integer): integer; stdcall;

implementation

uses
  sysutils,sec;

function NearestNode;
var
  inp: textfile;
  outp: textfile;
  X,Y: array of double;
  x1,y1,mindist,dist: double;
  i,j,minnode: integer;
  nodex: array of integer;

  procedure QuickSort(iLo, iHi: longInt);
  var
    Lo,Hi,T: longInt;
    Mid: double;
  begin
    Lo:= iLo;
    Hi:= iHi;
    Mid:= X[nodex[(Lo + Hi) div 2]];
    repeat
      while X[nodex[Lo]]<Mid do Inc(Lo);
      while X[nodex[Hi]]>Mid do Dec(Hi);
      if Lo<=Hi then
      begin
        T:= nodex[Lo]; nodex[Lo]:= nodex[Hi]; nodex[Hi]:= T;
        Inc(Lo);
        Dec(Hi);
      end;
    until Lo>Hi;
    if Hi>iLo then QuickSort(iLo,Hi);
    if Lo<iHi then QuickSort(Lo,iHi);
  end;

  procedure Find(Xv,Yv: double; var node: integer; var dist: double);
  var
    Lo,Hi,Mid,MidE,MidW: longint;
    stopW,stopE: boolean;
    D2: double;
  begin
    Lo:= 1;
    Hi:= count;
    repeat
      Mid:= (Lo + Hi) div 2;
      if X[nodex[mid]]<Xv then Lo:= Mid else Hi:= Mid;
    until Hi-Lo<=2;
    MidE:= (Lo + Hi) div 2;
    MidW:= MidE;
    dist:= AirDistPos(Xv,X[nodex[MidE]],Yv,Y[nodex[MidE]]);
    node:= nodex[midE];
    stopW:= false;
    stopE:= false;
    repeat
      // test the "west"
      if not stopW then
      begin
        dec(MidW);
        if MidW>=1 then
        begin
          if AirDist2(Yv,Y[nodex[MidW]])<dist then
          begin
            D2:= AirDistPos(Xv,X[nodex[MidW]],Yv,Y[nodex[MidW]]);
            if D2<dist then
            begin
              dist:= D2;
              node:= nodex[MidW];
            end else
            begin
              D2:= AirDist1(Xv,X[nodex[MidW]],Yv);
              if D2>dist then stopW:= true;
            end;
          end else
          begin
            D2:= AirDist1(Xv,X[nodex[MidW]],Yv);
            if D2>dist then stopW:= true;
          end;
        end;
      end;
      // test the "east"
      if not stopE then
      begin
        inc(MidE);
        if MidE<=count then
        begin
          if AirDist2(Yv,Y[nodex[MidE]])<dist then
          begin
            D2:= AirDistPos(Xv,X[nodex[MidE]],Yv,Y[nodex[MidE]]);
            if D2<dist then
            begin
              dist:= D2;
              node:= nodex[MidE];
            end else
            begin
              D2:= AirDist1(Xv,X[nodex[MidE]],Yv);
              if D2>dist then stopE:= true;
            end;
          end else
          begin
            D2:= AirDist1(Xv,X[nodex[MidE]],Yv);
            if D2>dist then stopE:= true;
          end;
        end;
      end;
    until ((MidE>=count) or stopE) and ((MidW<=1) or stopW);
  end;

begin
  coordtype:= MainCoord;
  result:= 0;
  try try
    setlength(x,count+1);
    setlength(y,count+1);
    // read x/y coordinates for "stores"
    assignfile(inp,'tmp1.txt');
    reset(inp);
    for i:= 1 to count do read(inp,x[i],y[i]);
    closefile(inp);
    if coordtype=1 then
    begin
      for i:= 1 to count do x[i]:= x[i]/180*pi;
      for i:= 1 to count do y[i]:= y[i]/180*pi;
    end;

    if maxlimit=0 then
    begin
      // create index
      setlength(nodex,count+1);
      for i:= 1 to count do nodex[i]:= i;
      quicksort(1,count);
    end;

    //read x/y coordinates
    assignfile(inp,'tmp2.txt');
    reset(inp);
    assignfile(outp,'nearest.txt');
    rewrite(outp);
    writeln(outp,'_ID1 _ID2 Distance');
    i:= 1;
    while not eof(inp) do
    begin
      read(inp,x1,y1);
      if coordtype=1 then x1:= x1/180*pi;
      if coordtype=1 then y1:= y1/180*pi;
      if maxlimit=0 then
      begin
        find(x1,y1,minnode,mindist);
        writeln(outp,i,' ',minnode,' ',mindist);
      end else
      begin
        for j:= 1 to count do
        begin
          dist:= AirDistPos(x1,x[j],y1,y[j]);
          if dist<maxlimit then writeln(outp,i,' ',j,' ',dist);
        end;
      end;
      inc(i);
    end;
    closefile(inp);
    closefile(outp);
  except
    on exception do result:= -1;
  end;
  finally
    if maxlimit=0 then finalize(nodex);
    finalize(x);
    finalize(y);
  end;
end;

end.
