unit voronoi;

interface

function Voronoi_Proc(N: integer; Xmode, XSlope: smallint; XZfieldname: pansichar): integer; stdcall;
function Voronoi_Proc2(N: integer; Xmode, XSlope: smallint; XZfieldname: pansichar; filename: pansichar): integer; stdcall;


implementation

uses
  SysUtils,
  rwnet_coordcostsitelist,
  rwnet_voronoi,
  rwnet_giswriter;

//  0: Tri_Line
//  1: Tri_Polygon
//  2: Voronoi_Line
//  3: Voronoi_polygon

function Voronoi_Proc;
begin
  result:= Voronoi_Proc2(N,Xmode,XSlope,XZfieldname,'~coordsys.mif');
end;

function Voronoi_Proc2;
var
  f: textfile;
  line: string;
  VO: TVoronoi;
  VO_out: TGISwrite;
  PG: TPolyGeneration;
  CCS: TCoordCostSite;
begin
  VO_out:= TGISwriteMIF.create;
  VO_out.FileName:= '~output';
  VO_out.CompactMIF:= true;

  // get coordsys clause from ~coordsys.mif
  assignfile(f,filename);
  reset(f);
  repeat
    readln(f,line);
    if pos('COORDSYS',uppercase(line))>0 then VO_out.CoordSys:= line;
  until eof(f);
  closefile(f);
  deletefile(filename);

  // read from ~site.txt to TPolyGeneration
  PG:= TPolyGeneration.create;
  assignfile(f,'~site.txt');
  reset(f);
  while not eof(f) do
  begin
    readln(f,CCS.P.x,CCS.P.y,CCS.Cost);
    PG.CoordCostSiteList.Add(CCS);
  end;
  closefile(f);

  // actual voronoi calculation
  VO:= TVoronoi.create;
  VO.GISwrite:= VO_out;
  VO.mode:= TVoronoiMode(Xmode);
  VO.Zfieldname:= XZfieldname;
  VO.slope:= (Xslope=1);
  VO.PolyGeneration:= PG;
  result:= VO.execute;
  VO.free;

  PG.Free;
  VO_out.Free;
end;

end.
